diff mbox series

[v3,1/2] btrfs: add a test case for btrfs seed device delete

Message ID 07f630546b05c655fc68c38a695f67176673aa21.1603196609.git.anand.jain@oracle.com (mailing list archive)
State New, archived
Headers show
Series add seed delete test case and fix btrfs/163 | expand

Commit Message

Anand Jain Oct. 20, 2020, 12:32 p.m. UTC
This is a regression test for the issue fixed by the kernel commit
b5ddcffa3777 (btrfs: fix put of uninitialized kobject after seed device
delete).

In this test case, we verify the seed device delete on a sprouted
filesystem.

Signed-off-by: Anand Jain <anand.jain@oracle.com>
---
v3: Add commit id for the kernel patch mentioned in the change log and
the header.
    Fix to _supported_fs btrfs
    Drop _supported_os Linux
    Use define AWK_PROG
    Drop the directIO in xfs_io it has no use
    Make it a new test case 225

v2: drop the sysfs layout check as it breaks the test-case backward
compatibility.

 tests/btrfs/225     | 82 +++++++++++++++++++++++++++++++++++++++++++++
 tests/btrfs/225.out | 15 +++++++++
 tests/btrfs/group   |  1 +
 3 files changed, 98 insertions(+)
 create mode 100755 tests/btrfs/225
 create mode 100644 tests/btrfs/225.out

Comments

Filipe Manana Oct. 20, 2020, 12:51 p.m. UTC | #1
On Tue, Oct 20, 2020 at 1:34 PM Anand Jain <anand.jain@oracle.com> wrote:
>
> This is a regression test for the issue fixed by the kernel commit
> b5ddcffa3777 (btrfs: fix put of uninitialized kobject after seed device
> delete).
>
> In this test case, we verify the seed device delete on a sprouted
> filesystem.
>
> Signed-off-by: Anand Jain <anand.jain@oracle.com>

Reviewed-by: Filipe Manana <fdmanana@suse.com>

Looks good, thanks.

> ---
> v3: Add commit id for the kernel patch mentioned in the change log and
> the header.
>     Fix to _supported_fs btrfs
>     Drop _supported_os Linux
>     Use define AWK_PROG
>     Drop the directIO in xfs_io it has no use
>     Make it a new test case 225
>
> v2: drop the sysfs layout check as it breaks the test-case backward
> compatibility.
>
>  tests/btrfs/225     | 82 +++++++++++++++++++++++++++++++++++++++++++++
>  tests/btrfs/225.out | 15 +++++++++
>  tests/btrfs/group   |  1 +
>  3 files changed, 98 insertions(+)
>  create mode 100755 tests/btrfs/225
>  create mode 100644 tests/btrfs/225.out
>
> diff --git a/tests/btrfs/225 b/tests/btrfs/225
> new file mode 100755
> index 000000000000..730d9645f34c
> --- /dev/null
> +++ b/tests/btrfs/225
> @@ -0,0 +1,82 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +# Copyright (c) 2020 Oracle. All Rights Reserved.
> +#
> +# FS QA Test 225
> +#
> +# Test for seed device-delete on a sprouted FS.
> +# Requires kernel patch
> +#    b5ddcffa3777  btrfs: fix put of uninitialized kobject after seed device delete
> +#
> +# Steps:
> +#  Create a seed FS. Add a RW device to make it sprout FS and then delete
> +#  the seed device.
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1       # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +       cd /
> +       rm -f $tmp.*
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +
> +# remove previous $seqres.full before test
> +rm -f $seqres.full
> +
> +# real QA test starts here
> +
> +# Modify as appropriate.
> +_supported_fs btrfs
> +_require_test
> +_require_scratch_dev_pool 2
> +
> +_scratch_dev_pool_get 2
> +
> +seed=$(echo $SCRATCH_DEV_POOL | $AWK_PROG '{print $1}')
> +sprout=$(echo $SCRATCH_DEV_POOL | $AWK_PROG '{print $2}')
> +
> +_mkfs_dev $seed
> +_mount $seed $SCRATCH_MNT
> +
> +$XFS_IO_PROG -f -c "pwrite -S 0xab 0 1M" $SCRATCH_MNT/foo > /dev/null
> +_scratch_unmount
> +$BTRFS_TUNE_PROG -S 1 $seed
> +
> +# Mount the seed device and add the rw device
> +_mount -o ro $seed $SCRATCH_MNT
> +$BTRFS_UTIL_PROG device add -f $sprout $SCRATCH_MNT
> +_scratch_unmount
> +
> +# Now remount
> +_mount $sprout $SCRATCH_MNT
> +$XFS_IO_PROG -f -c "pwrite -S 0xcd 0 1M" $SCRATCH_MNT/bar > /dev/null
> +
> +echo --- before delete ----
> +od -x $SCRATCH_MNT/foo
> +od -x $SCRATCH_MNT/bar
> +
> +$BTRFS_UTIL_PROG device delete $seed $SCRATCH_MNT
> +_scratch_unmount
> +_btrfs_forget_or_module_reload
> +_mount $sprout $SCRATCH_MNT
> +
> +echo --- after delete ----
> +od -x $SCRATCH_MNT/foo
> +od -x $SCRATCH_MNT/bar
> +
> +_scratch_dev_pool_put
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/btrfs/225.out b/tests/btrfs/225.out
> new file mode 100644
> index 000000000000..2e5d6ebee2c3
> --- /dev/null
> +++ b/tests/btrfs/225.out
> @@ -0,0 +1,15 @@
> +QA output created by 225
> +--- before delete ----
> +0000000 abab abab abab abab abab abab abab abab
> +*
> +4000000
> +0000000 cdcd cdcd cdcd cdcd cdcd cdcd cdcd cdcd
> +*
> +4000000
> +--- after delete ----
> +0000000 abab abab abab abab abab abab abab abab
> +*
> +4000000
> +0000000 cdcd cdcd cdcd cdcd cdcd cdcd cdcd cdcd
> +*
> +4000000
> diff --git a/tests/btrfs/group b/tests/btrfs/group
> index 9ad33baa8119..960981e57eb1 100644
> --- a/tests/btrfs/group
> +++ b/tests/btrfs/group
> @@ -226,3 +226,4 @@
>  222 auto quick send
>  223 auto quick replace trim
>  224 auto quick qgroup
> +225 auto quick volume seed
> --
> 2.25.1
>
diff mbox series

Patch

diff --git a/tests/btrfs/225 b/tests/btrfs/225
new file mode 100755
index 000000000000..730d9645f34c
--- /dev/null
+++ b/tests/btrfs/225
@@ -0,0 +1,82 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Oracle. All Rights Reserved.
+#
+# FS QA Test 225
+#
+# Test for seed device-delete on a sprouted FS.
+# Requires kernel patch
+#    b5ddcffa3777  btrfs: fix put of uninitialized kobject after seed device delete
+#
+# Steps:
+#  Create a seed FS. Add a RW device to make it sprout FS and then delete
+#  the seed device.
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs btrfs
+_require_test
+_require_scratch_dev_pool 2
+
+_scratch_dev_pool_get 2
+
+seed=$(echo $SCRATCH_DEV_POOL | $AWK_PROG '{print $1}')
+sprout=$(echo $SCRATCH_DEV_POOL | $AWK_PROG '{print $2}')
+
+_mkfs_dev $seed
+_mount $seed $SCRATCH_MNT
+
+$XFS_IO_PROG -f -c "pwrite -S 0xab 0 1M" $SCRATCH_MNT/foo > /dev/null
+_scratch_unmount
+$BTRFS_TUNE_PROG -S 1 $seed
+
+# Mount the seed device and add the rw device
+_mount -o ro $seed $SCRATCH_MNT
+$BTRFS_UTIL_PROG device add -f $sprout $SCRATCH_MNT
+_scratch_unmount
+
+# Now remount
+_mount $sprout $SCRATCH_MNT
+$XFS_IO_PROG -f -c "pwrite -S 0xcd 0 1M" $SCRATCH_MNT/bar > /dev/null
+
+echo --- before delete ----
+od -x $SCRATCH_MNT/foo
+od -x $SCRATCH_MNT/bar
+
+$BTRFS_UTIL_PROG device delete $seed $SCRATCH_MNT
+_scratch_unmount
+_btrfs_forget_or_module_reload
+_mount $sprout $SCRATCH_MNT
+
+echo --- after delete ----
+od -x $SCRATCH_MNT/foo
+od -x $SCRATCH_MNT/bar
+
+_scratch_dev_pool_put
+
+# success, all done
+status=0
+exit
diff --git a/tests/btrfs/225.out b/tests/btrfs/225.out
new file mode 100644
index 000000000000..2e5d6ebee2c3
--- /dev/null
+++ b/tests/btrfs/225.out
@@ -0,0 +1,15 @@ 
+QA output created by 225
+--- before delete ----
+0000000 abab abab abab abab abab abab abab abab
+*
+4000000
+0000000 cdcd cdcd cdcd cdcd cdcd cdcd cdcd cdcd
+*
+4000000
+--- after delete ----
+0000000 abab abab abab abab abab abab abab abab
+*
+4000000
+0000000 cdcd cdcd cdcd cdcd cdcd cdcd cdcd cdcd
+*
+4000000
diff --git a/tests/btrfs/group b/tests/btrfs/group
index 9ad33baa8119..960981e57eb1 100644
--- a/tests/btrfs/group
+++ b/tests/btrfs/group
@@ -226,3 +226,4 @@ 
 222 auto quick send
 223 auto quick replace trim
 224 auto quick qgroup
+225 auto quick volume seed